/**
 * after processing library
 *
 */
import processing.serial.*;
import controlP5.*;
PImage bg; //background

ControlP5 cp5;
Serial myPort;  // The serial port

int knobValue = 120;

Knob myKnobA;
Knob myKnobB;

int sliderValue = 100;

int bo = 10; //int

Button drawerinsert;
Button readservo; 
Button hallinsert; 



String reading = "";
int[] nums; 

void setup() {
  size(1024, 768);
  smooth();
  noStroke();
  // The background image must be the same size as the parameters
  // into the size() method. In this program, the size of the image
  // is 640 x 360 pixels.
  bg = loadImage("moonwalk.jpg");

  cp5 = new ControlP5(this);

  Button drawerinsert = cp5.addButton("switch opened")
    .setValue(0)
    .setPosition(100, 100)
    .setSize(200, 19)
    ;

  Button readservo = cp5.addButton("servoangle")
    .setValue(0)
    .setPosition(400, 100)
    .setSize(200, 19)
    ;

  Button hallinsert = cp5.addButton("insert ")
    .setValue(0)
    .setPosition(700, 100)
    .setSize(200, 19)
    ;




  myKnobA = cp5.addKnob("OPEN POSITION")
    .setRange(0, 180) //knob value
    .setValue(50)
    .setPosition(90, 400)
    .setRadius(70)
    .setColorForeground(color(255))
    .setDragDirection(Knob.VERTICAL)
    ;

  myKnobB = cp5.addKnob("CLOSE POSITION")
    .setRange(0, 180) //knob value
    .setValue(50)
    .setPosition(380, 400)
    .setRadius(70)
    .setColorForeground(color(255))
    .setDragDirection(Knob.VERTICAL)
    ;


  cp5.addButton("buttonA")
    .setPosition(130, 600)
    .setImages(loadImage("Arrow-Left.png"), loadImage("Arrow-Right.png"), loadImage("Refresh.png"))
    .updateSize();
  cp5.addButton("buttonB")
    .setPosition(420, 600)
    .setImages(loadImage("Arrow-Left.png"), loadImage("Arrow-Right.png"), loadImage("Refresh.png"))
    .updateSize();

  cp5.addSlider("sliderValue")
    .setPosition(700, 450)
    .setRange(0, 255)
    .setSize(200, 50) 
    ;


  try
  {
    // Open the port you are using at the rate you want:
    myPort = new Serial(this, Serial.list()[0], 9600);
  } 
  catch (Exception e) {
    e.printStackTrace();
  }

  // prove
  drawerinsert.setLabel("text");

myPort.write("mandami le info");  

  while ( myPort.available() > 0) {  // If data is available,
    reading += myPort.read();         // read it and store it in val
    //reads everything that comes from an arduino divided by a space that is organized with a position
  }
  nums = int(split(reading, ' '));
  reading = "";
  if (nums[0] == 1) {
    drawerinsert.setLabel("drawer insert");
  } else {
    drawerinsert.setLabel("no drawers");
  }
  readservo.setLabel("angleservo" + nums[1]);
  
  if (nums[2] == 1) {
    hallinsert.setLabel("block insert");
  } else {
    hallinsert.setLabel("no block");
  }

}     

void draw() {
  background(bg);
  // background(myColorBackground);
  fill(sliderValue);
}





void knob(int theValue) {
  // myColorBackground = color(theValue);
  println("A"+theValue);
}




void keyPressed() {
  switch(key) {
    case('1'):
    myKnobA.setValue(180);
    break;
    case('2'):
    myKnobB.setConstrained(false).hideTickMarks().snapToTickMarks(false);
    break;
    case('3'):
    myKnobA.shuffle();
    myKnobB.shuffle();
    break;
  }
}

/* myKnobB = cp5.addKnob("knobValue")
 .setRange(0,255)
 .setValue(220)
 .setPosition(100,210)
 .setRadius(50)
 .setNumberOfTickMarks(10)
 .setTickMarkLength(4)
 .snapToTickMarks(true)
 .setColorForeground(color(255))
 .setColorBackground(color(0, 160, 100))
 .setColorActive(color(255,255,0))
 .setDragDirection(Knob.HORIZONTAL)
 ;
 */
